SystemOrganization addCategory: #'Phidget-Mock'!
SystemOrganization addCategory: #'Phidget-Mock-Tests'!

CsComposition subclass: #PhdMkPhidgetLayer
	instanceVariableNames: 'phidgets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

PhdMkPhidgetLayer subclass: #PhdMkInterfaceKitLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

!PhdMkInterfaceKitLayer class methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 15:23'!
computeLayers
	^ { PhdMkInterfaceKitLayer new }! !

!PhdMkInterfaceKitLayer methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 12:41'!
mockClass
	^ PhdMkInterfaceKitData! !

!PhdMkInterfaceKitLayer methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 15:23'!
variedPhidgetClass
	^ PhdCrInterfaceKit class! !

!PhdMkPhidgetLayer class methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 13:01'!
computeLayers
	^ self subclassResponsibility! !

!PhdMkPhidgetLayer methodsFor: 'phidgets list' stamp: 'lk 11/22/2009 10:33'!
addMock: aMock

	aMock id: self nextPhidgetId.
	phidgets add: aMock.! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/26/2009 21:16'!
advicePrimClose
"primClose: phidgetidArray"
	"Close the Phidget with given id. 
	Return 1 if the operation succeeded, or other values otherwise."
	
	^ CsAroundVariation 
		target: [ self variedPhidgetClass -> #primClose: ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod | 
			| mock result |
			result := nil. "default return value. will be set to 1 if the phidget is valid and can be closed."
			mock := layer phidgetForId: (arguments at: 1).
			mock ifNotNil: [ mock open: false. result := 1 ].
			result
		]! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/26/2009 22:06'!
advicePrimGetDeviceClass
"primGetDeviceClass: phidgetIdArray"
	"Answer the device class id of the opened device with given id. Answers -1 if an error occurred."
	
	^ CsAroundVariation 
		target: [ self variedPhidgetClass -> #primGetDeviceClass: ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod | 
			| mock result |
			result := -1. "default return value. will be set to the deive class if the operation suceeds."
			mock := self phidgetForId: (arguments at: 1).
			mock ifNotNil: [ result := mock getDeviceClass ].
			result
		]! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/26/2009 22:08'!
advicePrimGetDeviceName
"primGetDeviceName: phidgetIdArray"
	"Answer a byte array of the name of the opened device with given id. Answers nil if an error occurred."
	
	^ CsAroundVariation 
		target: [ self variedPhidgetClass -> #primGetDeviceName: ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod | 
			| mock result |
			result := nil. "default return value. will be set to the deive name if the operation suceeds."
			mock := self phidgetForId: (arguments at: 1).
			mock ifNotNil: [ result := mock getDeviceName ].
			result
		]! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/26/2009 22:08'!
advicePrimGetDeviceType
"primGetDeviceType: phidgetIdArray"
	"Answer the device type id of the opened device with given id. Answers -1 if an error occurred."
	
	^ CsAroundVariation 
		target: [ self variedPhidgetClass -> #primGetDeviceType: ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod | 
			| mock result |
			result := -1. "default return value. will be set to the deive type if the operation suceeds."
			mock := self phidgetForId: (arguments at: 1).
			mock ifNotNil: [ result := mock getDeviceType ].
			result
		]! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/26/2009 21:26'!
advicePrimGetNewId
"primGetNewId"
	"Create a new the Interface Kit object. Returns a new id for the Phidget, or nil if there was an error."
	
	^ CsAroundVariation
		target: [ self variedPhidgetClass -> #primGetNewId ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod |
			| mock |
			mock := self mockClass new: self.
			mock id
		]! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/26/2009 21:14'!
advicePrimIsAttached
"primIsAttached: phidgetidArray"
	"Returns 1 if the Phidget is attached, and other values otherwise."
	
	^ CsAroundVariation 
		target: [ self variedPhidgetClass -> #primIsAttached: ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod | 
			| mock result |
			result := nil. "default return value. will be set to 1 if the phidget is valid and attached."
			mock := self phidgetForId: (arguments at: 1).
			mock isNil not and: [ mock attached ifTrue: [ result := 1 ] ].
			result
		]! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/26/2009 21:25'!
advicePrimIsValid
"primIsValid: phidgetidArray"
	"Returns 1 if the Phidget id is valid, or other values otherwise."
	
	^ CsAroundVariation
		target: [ self variedPhidgetClass -> #primIsValid: ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod |
			"it is valid if we find a mock with this id"
			(self phidgetForId: (arguments at: 1))
				ifNil: [ nil ]
				ifNotNil: [ 1 ]
		]! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/26/2009 21:18'!
advicePrimOpenWithSerial
"primOpen: phidgetidArray withSerial: serial"
	"Opens the Phidget with the given serial number.
	Return 1 if the operation succeeded, or other values otherwise."
	
	^ CsAroundVariation 
		target: [ self variedPhidgetClass -> #primOpen:withSerial: ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod | 
			| mock result |
			result := nil. "default return value. will be set to 1 if the phidget is valid and can be opened."
			mock := layer phidgetForId: (arguments at: 1).
			mock ifNotNil: [
				mock open: true.
				mock serialNumber: (arguments at: 2).
				result := 1
			].
			result
		]! !

!PhdMkPhidgetLayer methodsFor: 'phidgets list' stamp: 'lk 11/22/2009 11:14'!
assureUniqueId: aPhidgetId
	| max |
	max := self phidgets size = 0
		ifTrue: [ TimeStamp new ]
		ifFalse: [ (self phidgets collectValues: [ :each | each id ]) max ].
	^ aPhidgetId > max
		ifTrue: [ aPhidgetId ]
		ifFalse: [ max + 1 ]! !

!PhdMkPhidgetLayer methodsFor: 'initialization' stamp: 'lk 11/21/2009 18:59'!
initialize
	super initialize.
	
	phidgets := PhdMkLinkedList new.! !

!PhdMkPhidgetLayer methodsFor: 'polymorph class names' stamp: 'lk 11/22/2009 12:39'!
mockClass
	^ self subclassResponsibility! !

!PhdMkPhidgetLayer methodsFor: 'phidgets list' stamp: 'lk 11/22/2009 10:23'!
nextPhidgetId
	| now |
	now := TimeStamp now.
	^ self assureUniqueId: now.! !

!PhdMkPhidgetLayer methodsFor: 'phidgets list' stamp: 'lk 11/22/2009 16:14'!
phidgetForId: phidgetId 
	^ phidgets values detect: [ :each | each id = phidgetId ] ifNone: [ nil ]! !

!PhdMkPhidgetLayer methodsFor: 'accessing' stamp: 'lk 11/21/2009 19:15'!
phidgets
	^ phidgets! !

!PhdMkPhidgetLayer methodsFor: 'polymorph class names' stamp: 'lk 11/22/2009 12:43'!
variedPhidgetClass
	^ self subclassResponsibility! !

LinkedList subclass: #PhdMkLinkedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 20:02'!
addLast: value
	|item|
	item := PhdMkLinkedListItem new: value.
	super addLast: item.! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:16'!
collectValues: aBlock
	| values |
	values := self collect: [ :each | each value ].
	^ values collect: aBlock! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:33'!
itemsUnique: aBlock
	| items |	
	items := self collectValues: aBlock.
	
	^ items size > 0
		ifTrue: [ (items contains: [ :each |
			"if more than one item was removed in copyWithout, this item is not unique"
			(items copyWithout: each) size ~= (items size - 1) ]) not
		] ifFalse: [ true ]! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 20:03'!
valueAt: index
	| item |
	item := self at: index.
	^ item value! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 20:03'!
valueAt: index ifAbsent: aBlock
	| item |
	item := self at: index ifAbsent: aBlock.
	^ item
		ifNil: [ nil ]
		ifNotNil: [ item value ]! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 12:34'!
values
	^ self collect: [ :each | each value ]! !

Object subclass: #PhdMkLinkedListItem
	instanceVariableNames: 'nextLink value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

!PhdMkLinkedListItem class methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:04'!
new: value

	^ self new
		value: value! !

!PhdMkLinkedListItem methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:02'!
nextLink
	^ nextLink! !

!PhdMkLinkedListItem methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:01'!
nextLink: newNextLink
	nextLink := newNextLink.! !

!PhdMkLinkedListItem methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:00'!
value
	^ value! !

!PhdMkLinkedListItem methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:00'!
value: newValue
	value := newValue.! !

Object subclass: #PhdMkPhidgetData
	instanceVariableNames: 'id attached serialNumber open deviceClass deviceName deviceType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

PhdMkPhidgetData subclass: #PhdMkInterfaceKitData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

!PhdMkPhidgetData class methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 10:31'!
new: aMockLayer

	| instance |
	instance := self new.
	aMockLayer addMock: instance.
	^ instance
	! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 16:11'!
attached
	^ attached! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 16:11'!
attached: aBoolean
	attached := aBoolean.! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/26/2009 21:57'!
deviceClass: anInteger
	deviceClass := anInteger.! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/26/2009 21:57'!
deviceName: aString
	deviceName := aString.! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/26/2009 21:57'!
deviceType: anInteger
	deviceType := anInteger.! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/26/2009 22:07'!
getDeviceClass
	"answer the device class. the real value can only be retrieved if the phidget is attached and open.
	Else return a default value (-1)."
	
	^ self attached & self open
		ifTrue: [ deviceClass ]
		ifFalse: [ -1 ]! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/26/2009 22:07'!
getDeviceName
	"answer the device name. the real value can only be retrieved if the phidget is attached and open.
	Else return a default value (nil)."
	
	^ self attached & self open
		ifTrue: [ deviceName ]
		ifFalse: [ nil ]! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/26/2009 22:08'!
getDeviceType
	"answer the device type. the real value can only be retrieved if the phidget is attached and open.
	Else return a default value (-1)."
	
	^ self attached & self open
		ifTrue: [ deviceType ]
		ifFalse: [ -1 ]! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 10:51'!
id
	^ id! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 10:51'!
id: newId
	id := newId.! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/26/2009 21:58'!
initialize
	super initialize.
	
	open := false.
	attached := false.
	serialNumber := -1.
	deviceClass := -1.
	deviceName := nil.
	deviceType := -1.! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 14:30'!
open
	^ open! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 14:30'!
open: aBoolean
	open := aBoolean.! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 14:21'!
serialNumber
	^ serialNumber! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 14:30'!
serialNumber: anInteger
	serialNumber := anInteger.! !

TestCase subclass: #PhdMkInterfaceKitLayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock-Tests'!

!PhdMkInterfaceKitLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 13:02'!
testComputeLayers
	| layers layerClasses |
	layers := PhdMkInterfaceKitLayer computeLayers.
	layerClasses := layers collect: [:each | each class].
	self assert: ( layerClasses includesAllOf: { PhdMkInterfaceKitLayer } ).! !

TestCase subclass: #PhdMkPhidgetLayerTest
	instanceVariableNames: 'layer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock-Tests'!

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:43'!
layerClass
	^ PhdMkInterfaceKitLayer! !

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:44'!
phidgetClass
	^ PhdCrInterfaceKit! !

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:44'!
setUp

	layer := self layerClass new.! !

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/26/2009 21:05'!
testPhidgetsList
	"Phidgets that are created using the PhdMkPhidgetLayer should be registered in the layer's list"
	
	| phidget1 phidget2 phidget3 ids |
	self assert: layer phidgets size = 0.
	[{layer}] useAsLayersFor: [
		phidget1 := self phidgetClass new.
		phidget2 := self phidgetClass new.
		phidget3 := self phidgetClass new.
	].

	self assert: layer phidgets size = 3.
	"compare the ids"
	ids := layer phidgets values collect: [ :each | each id ].
	self assert: (ids includesAllOf: { phidget1 id . phidget2 id . phidget3 id })! !

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/26/2009 21:05'!
testUniqueIds
	"every Phidegt should get a unique id"

	[{layer}] useAsLayersFor: [
		self phidgetClass new.
		self phidgetClass new.
		self phidgetClass new.
	].
	self assert: (layer phidgets itemsUnique: [ :each | each id ]).! !
